diff --git a/src/child.c b/src/child.c
index d0bbff24..612c5b97 100644
--- a/src/child.c
+++ b/src/child.c
@@ -1052,6 +1052,11 @@ do_child_fork(int argc, char *argv[], int moni, bool launch)
     //setenv("MINTTY_CHILD", "1", true);
 
 #if CYGWIN_VERSION_DLL_MAJOR >= 1005
+    if (shortcut) {
+      shell_exec(shortcut);
+      exit(0);
+    }
+
     execv("/proc/self/exe", argv);
 #else
     // /proc/self/exe isn't available before Cygwin 1.5, so use argv[0] instead.
diff --git a/src/win.h b/src/win.h
index b7bac142..e4fde623 100644
--- a/src/win.h
+++ b/src/win.h
@@ -14,6 +14,7 @@
 extern char * home;
 extern char * cmd;
 extern bool icon_is_from_shortcut;
+extern wstring shortcut;
 
 extern void exit_mintty(void);
 extern void report_pos(void);
diff --git a/src/winclip.c b/src/winclip.c
index 09c2a03b..c582d1fa 100644
--- a/src/winclip.c
+++ b/src/winclip.c
@@ -49,7 +49,7 @@ shell_exec_thread(void *data)
   return 0;
 }
 
-static void
+void
 shell_exec(wstring wpath)
 // frees wpath
 {
diff --git a/src/winmain.c b/src/winmain.c
index d0d5cfe5..3d160383 100644
--- a/src/winmain.c
+++ b/src/winmain.c
@@ -65,6 +65,7 @@ ATOM class_atom;
 static char **main_argv;
 static int main_argc;
 static bool invoked_from_shortcut = false;
+wstring shortcut = 0;
 static bool invoked_with_appid = false;
 
 
@@ -2117,7 +2118,7 @@ show_iconwarn(wchar * winmsg)
 
 
 /*
-  Message handling.
+   Message handling.
  */
 
 #define dont_debug_messages
@@ -2331,7 +2332,10 @@ static struct {
           int moni = search_monitors(&x, &y, mon, true, 0);
           child_fork(main_argc, main_argv, moni);
         }
-        when IDM_NEW_MONI: child_fork(main_argc, main_argv, (int)lp);
+        when IDM_NEW_MONI: {
+          int moni = lp;
+          child_fork(main_argc, main_argv, moni);
+        }
         when IDM_COPYTITLE: win_copy_title();
       }
     }
@@ -3626,6 +3630,7 @@ main(int argc, char *argv[])
 
   bool wdpresent = true;
   if (invoked_from_shortcut) {
+    shortcut = wcsdup(sui.lpTitle);
     wchar * icon = get_shortcut_icon_location(sui.lpTitle, &wdpresent);
 # ifdef debuglog
     fprintf(mtlog, "icon <%ls>\n", icon); fflush(mtlog);
diff --git a/src/winpriv.h b/src/winpriv.h
index ca932e28..26b99ecf 100644
--- a/src/winpriv.h
+++ b/src/winpriv.h
@@ -86,6 +86,7 @@ extern bool win_key_up(WPARAM, LPARAM);
 extern void win_led(int led, bool set);
 
 extern wchar * dewsl(wchar * wpath);
+extern void shell_exec(wstring wpath);
 extern void win_init_drop_target(void);
 
 extern wstring wslicon(wchar * params);
